/*
 * menu.c
 *
 *  Created on: 06.12.2013
 *      Author: alone
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "menu.h"
#include "hd44780.h"
#include "stepper.h"
#include "transomot.h"

uint8_t menu_diameter_pos[6] = { 0, 0, 5, 0, MENU_EDIT_WIRE }; // позиция и длина на экране

uint8_t menu_layer_count[5] = { 2, 1, 3, 0, MENU_EDIT_LAYER_COUNT };

uint8_t menu_layer_counter[4] = { 13, 0, 3 };

uint8_t menu_cycles_counter[4] = { 12, 1, 4 };

char *directions[2] = { "<<<", ">>>" };
uint8_t menu_direction[3] = { 8, 0, 3 };

uint8_t menu_state = MENU_WORK;

char *reverse_states[2] = { "   ", "REV" };
uint8_t menu_reverse_state[3] = { 8, 1, 3 };

//struct MenuItem menu_items[5];

//struct MenuItem menu_items[] = {
//        .pos = 0,
//        .name = "Diameter",
//        .dot_pos = 1,
//        .param_len = 5
//};
//struct MenuItem menu_item1 = {
//    .pos = 0,
//    .name = "Diameter",
//    .dot_pos = 1,
//    .param_len = 5
//};


void initial_menu() {

  lcd_clrscr();
  char a1[16];
  char a2[16];

//  as example
//  0.224 w >>>  123
//  L:250 * REV 1234

//  strcpy(a1, "d:");
  strcpy(a1, diameter);
  strcat(a1, "   ");
  strcat(a1, directions[direction]);
  strcat(a1, "  ");
  strcat(a1, layer_counter);

//  sprintf(a2, "L:%s   %s  %s", layer_count, reverse_states[reverse_state], layer_counter);
  strcpy(a2, "L:");
  strcat(a2, layer_count);
  strcat(a2, "   ");
  strcat(a2, reverse_states[reverse_state]);
  strcat(a2, " ");
  strcat(a2, cycles_counter);

  lcd_goto(0, 0);
  lcd_prints(a1);
  lcd_goto(1, 0);
  lcd_prints(a2);
}

void show_diameter(void) {
  lcd_goto(menu_diameter_pos[1], menu_diameter_pos[0]);
  lcd_prints(diameter);
}

void show_direction(void) {
  lcd_goto(menu_direction[1], menu_direction[0]);
  lcd_prints(directions[direction]);
}

void show_cycles_counter(void) {
  uint8_t pos = menu_cycles_counter[MENU_X] + menu_cycles_counter[MENU_LENGTH]
      - strlen(cycles_counter);
  lcd_goto(menu_cycles_counter[1], pos);
  lcd_prints(cycles_counter);
}

void show_layer_count(void) {
//  lcd_goto(menu_layer_count[1], menu_layer_count[0]);
  lcd_goto(menu_layer_count[MENU_Y], menu_layer_count[MENU_X]);
  lcd_prints(layer_count);
}

void show_layer_counter() {
  uint8_t pos = menu_layer_counter[MENU_X] + menu_layer_counter[MENU_LENGTH]
      - strlen(layer_counter);
  lcd_goto(menu_layer_counter[1], menu_layer_counter[MENU_X]);
  lcd_prints("   ");

  lcd_goto(menu_layer_counter[1], pos);
  lcd_prints(layer_counter);
}

void switch_direction(void) {
  direction = !direction;
  show_direction();
}

void show_reverse_state(void) {
  lcd_goto(menu_reverse_state[1], menu_reverse_state[0]);
  lcd_prints(reverse_states[reverse_state]);
}

void switch_reverse(void) {
  reverse_state = !reverse_state;
  show_reverse_state();
}

void carret_to_begin_layer_pos(void) {
  lcd_goto(menu_layer_counter[MENU_Y], menu_layer_counter[MENU_X]);
  lcd_prints("<<<");
  uint16_t cnt = 0;

  if (layer_counter_dec == 0) {
    cnt = layer_count_dec;
  } else {
    cnt = layer_counter_dec;
  }

  for (int k = 0; k < cnt; k++) {
    for (int i = 0; i < step; i++) {
      left();
      sw_delay_ms(2);
    }
  }
  after_layer_carret_pos(0);

}

void carret_to_end_layer_pos(void) {
  lcd_goto(menu_layer_counter[MENU_Y], menu_layer_counter[MENU_X]);
  lcd_prints(">>>");

  for (int k = layer_counter_dec; k < layer_count_dec; k++) {
    for (int i = 0; i < step; i++) {
      right();
      sw_delay_ms(2);
    }
  }
  after_layer_carret_pos(0);
}

void after_layer_carret_pos(uint8_t count) {
  motor_free();
  layer_counter_dec = count;
  itoa(layer_counter_dec, layer_counter, 10);
  show_layer_counter();
}

void clear_counters() {
  strcpy(cycles_counter, "   0");
  cycles_counter_dec = 0;
  show_cycles_counter();

  strcpy(layer_counter, "  0");
  layer_counter_dec = 0;
  show_layer_counter();
}
