/*
 * rotator.c
 *
 *  Created on: 22.12.2013
 *      Author: alone
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <util/delay.h>

#include "hd44780.h"
#include "rotator.h"
#include "stepper.h"
#include "menu.h"
#include "transomot.h"
#include "kbd.h"

// на входе направление от датчика оборотов
void rotate(uint8_t rotor_direction) {

  if (rotor_direction == CLOCKWISE) { // движение по часовой стрелке
    clockwise_rotate();
  } else { // движение против часовой стрелки
    counterclockwise_rotate();
  }

  strcpy(layer_counter, "   ");
  itoa(layer_counter_dec, layer_counter, 10);
  itoa(cycles_counter_dec, cycles_counter, 10);
  show_layer_counter();
  show_cycles_counter();
}

// обработчик движения редуктора по часовой стрелке
void clockwise_rotate() {

  // первым делом крутим вал

  for (int i = 0; i < step; i++) {
    if (direction == LEFT_DIR) {
      left();
    }else{
      right();
    }
    sw_delay_ms(2);
  }
  motor_free();

  // увеличиваем счетчики
  layer_counter_dec++;
  cycles_counter_dec++;

  if (layer_counter_dec >= layer_count_dec) {
    layer_counter_dec = 0;
    if (reverse_state == 1) {
      switch_direction();
    }else{
      // stop signal
      reductor_power(CONF_REDUCTOR_PWR_OFF);
    }
  }
}

// обработчик движения редуктора против часовой стрелки
void counterclockwise_rotate() {
  for (int i = 0; i < step; i++) {
    if (direction == LEFT_DIR) {
      right();
    }else{
      left();
    }
    sw_delay_ms(2);
  }
  motor_free();

  // уменьшаем счетчики
  layer_counter_dec--;
  cycles_counter_dec--;

  if (layer_counter_dec <= 0) {
    layer_counter_dec = layer_count_dec;
    if (reverse_state == 1) {
      switch_direction();
    }else{
      // stop signal
      reductor_power(CONF_REDUCTOR_PWR_OFF);
    }
  }

}
