/*
 * save_params.h
 *
 *  Created on: 07.12.2013
 *      Author: alone
 */

#ifndef SAVE_PARAMS_H_
#define SAVE_PARAMS_H_



// EEPROM DEFINES
#define read_eeprom_byte(address) eeprom_read_byte ((const uint8_t*)address)
#define write_eeprom_byte(address,value) eeprom_write_byte ((uint8_t*)address,(uint8_t)value)
#define read_eeprom_word(address) eeprom_read_word ((const uint16_t*)address)
#define write_eeprom_word(address,value) eeprom_write_word ((uint16_t*)address,(uint16_t)value)
#define read_eeprom_dword(address) eeprom_read_dword ((const uint32_t*)address)
#define write_eeprom_dword(address,value) eeprom_write_dword ((uint32_t*)address,(uint32_t)value)
#define read_eeprom_array(address,value_p,length) eeprom_read_block ((void *)value_p, (const void *)address, length)
#define write_eeprom_array(address,value_p,length) eeprom_write_block ((const void *)value_p, (void *)address, length)

#define DIAMETER_ADDR 0
#define LAYER_COUNT_ADDR 5
#define LAYER_COUNTER_ADDR 8
#define CYCLES_COUNTER_ADDR 11
#define DIRECTION_ADDR 15
#define REV_ADDR 16

void save_parameters(void);
void restore_parameters(void);

#endif /* SAVE_PARAMS_H_ */
