/*
 * stepper.c
 *
 *  Created on: 05.12.2013
 *      Author: alone
 */
#include <avr/io.h>
//#include <avr/iom8.h>
#include <util/delay.h>
#include <string.h>

#include "stepper.h"
#include "transomot.h"

//unsigned char stepper_step_codes[8] = {
//    0b00100000,
//    0b00110000,
//    0b00010000,
//    0b00011000,
//    0b00001000,
//    0b00001100,
//    0b00000100,
//    0b00100100
//};

//unsigned char stepper_step_codes[4] = { 0b00100000, 0b00010000, 0b00001000,
//    0b00000100 };

//uint8_t step[8] = {0x01, 0x03 ,0x02, 0x06,0x04, 0x0c,0x08,0x09};

uint8_t stepper_step_codes[8][8] = {
    { 1, 0, 0, 0 },
    { 1, 1, 0, 0 },
    { 0, 1, 0, 0 },
    { 0, 1, 1, 0 },
    { 0, 0, 1, 0 },
    { 0, 0, 1, 1 },
    { 0, 0, 0, 1 },
    { 1, 0, 0, 1 }
};
unsigned char stepper_current_step;

void stepper_init(void) {
  STEPPER_PORT = 0x00;
  STEPPER_DDR = 0xff;
  stepper_current_step = 0;
}

void right() {
  if (stepper_current_step < STEPPER_MAX_STEPS) {
    stepper_current_step += 1;
  } else {
    stepper_current_step = 0;
  }
  stepper_send_data();
}

void slow_right(void) {
  right();
  sw_delay_ms(10);
}

void left(void) {
  if (stepper_current_step > 0) {
    stepper_current_step -= 1;
  } else {
    stepper_current_step = STEPPER_MAX_STEPS;
  }
  stepper_send_data();
}

void slow_left(void) {
  left();
  sw_delay_ms(10);
}

void stepper_send_data(void) {
  for (uint8_t i = 0; i < 4; i++) {
    switch (stepper_step_codes[stepper_current_step][i]) {
    case 0:
      STEPPER_PORT &= ~_BV(i+2);
      break;
    case 1:
      STEPPER_PORT |= _BV(i+2);
      break;
    }
  }

//  STEPPER_PORT |= (stepper_step_codes[stepper_current_step][0] << CONF_STP_P5) |
//                  (stepper_step_codes[stepper_current_step][1] << CONF_STP_P4) |
//                  (stepper_step_codes[stepper_current_step][2] << CONF_STP_P3) |
//                  (stepper_step_codes[stepper_current_step][3] << CONF_STP_P2);
}

void motor_free(void) {
//  STEPPER_PORT = 0b00000000;
  STEPPER_PORT &= ~_BV(CONF_STP_P2);
  STEPPER_PORT &= ~_BV(CONF_STP_P3);
  STEPPER_PORT &= ~_BV(CONF_STP_P4);
  STEPPER_PORT &= ~_BV(CONF_STP_P5);
//  STEPPER_PORT = (0 << CONF_STP_P2) | (0 << CONF_STP_P3) | (0 << CONF_STP_P4) | (0 << CONF_STP_P5);
}

